// Generated by CoffeeScript 1.10.0
var prettyPrint, structuredStackTrace, wrapCallSite;

structuredStackTrace = require('./structured-stack-trace');

wrapCallSite = require('./callsite/wrap');

prettyPrint = require('./utils').prettyPrint;

module.exports = function(options) {
  if (options == null) {
    options = {};
  }
  if (options.handleUncaughtExceptions == null) {
    options.handleUncaughtExceptions = true;
  }
  if (options.structuredStackTrace == null) {
    options.structuredStackTrace = false;
  }
  if (options.handleUncaughtExceptions) {
    process.on('uncaughtException', function(err) {
      prettyPrint(err, {
        colorize: process.stdout.isTTY
      });
      return process.exit(1);
    });
  }
  return Error.prepareStackTrace = function(err, stack) {
    var _stack, frame;
    _stack = (function() {
      var i, len, results;
      results = [];
      for (i = 0, len = stack.length; i < len; i++) {
        frame = stack[i];
        results.push(wrapCallSite(err, frame));
      }
      return results;
    })();
    if (options.structuredStackTrace) {
      err.structuredStackTrace = structuredStackTrace(err, stack);
    }
    return err + ((function() {
      var i, len, results;
      results = [];
      for (i = 0, len = _stack.length; i < len; i++) {
        frame = _stack[i];
        results.push('\n    at ' + frame);
      }
      return results;
    })()).join('');
  };
};

//# sourceMappingURL=install.js.map
